/*
** FILE NAME:	max.c
**
** PROJECT ID:	94-0040
**
** TITLE:	MaxI
**
** AUTHOR:	Ensigma Ltd.
**
** DESCRIPTION:	This routine searches input to find the first element with
**		the maximum value, and returns its address in max_ptr.
**
**		int MaxI(max_ptr, input, no_elements)
**
** PARAMETERS:
**              short **max_ptr     : address of pointer to maximum element
**              short input []      : array of input data
**              long no_elements    : size of the input buffer
**
** RETURNS:     EDSP_OK             : success
**              EDSP_BAD_ARG        : no_elements < 1
**
** MODIFICATION HISTORY:
**              1.0  15-9-95    Initial revision
*/

#include <math.h>
#include <ensigdsp.h>

int 
MaxI(short **max_ptr, short input[], long no_elements)
{
    /* Variable Declaration */
    int i, location = 0;
    short temp;

    /* Input argument error checking */
    if (no_elements < 1)
	return EDSP_BAD_ARG;

    temp = input[0];		/* Variable initialisation */

    for (i = 1; i < no_elements; i++)	/* Main Loop */
    {
	if (temp < input[i])
	{
	    temp = input[i];	/* Store the local maximum */
	    location = i;	/* store the index */
	}
    }

    *max_ptr = &input[location];/* get the address */

    return EDSP_OK;		/* Return success */
}
