;
; FILE NAME:    peak.asm
;
; PROJECT ID:   94-0040
;
; TITLE:        PeakI
;
; AUTHOR:       Ensigma Ltd.
;
; DESCRIPTION:  This file contains the peak finding function.
;

	.EXPORT	_PeakI

;REGISTER USAGE
;
;R4 -> OUTPUT
;R5 -> INPUT
;R6 -> NO

	.SECTION	P,CODE,ALIGN=4

; Preserve registers on stack
_PeakI:	MOV.L	R14,@-R15	;PUSH REGISTERS ON STACK
	MOV.L	R13,@-R15
	MOV.L	R12,@-R15
	MOV.L	R11,@-R15
	MOV.L	R10,@-R15
	MOV.L	R9,@-R15
	MOV.L	R8,@-R15
	STS.L	MACH,@-R15
	STS.L	MACL,@-R15
	STS.L	PR,@-R15

; Error checking
	CMP/PL	R6		;NO >0 ?
	BT	argOK

ERR:	BRA	RTN
	MOV	#1,R0		;R0= RETURN CODE

	.ALIGN	4
argOK:	MOV	#0,R1		;R1=MINIMUM VALUE
	MOV	R5,R3
	ADD	R6,R3
	ADD	R6,R3		;CALCULATE LAST DATA ADDRESS
	MOV	R5,@R4		;STORE DATA ADDRESS
	NOP

loop:	MOV.W	@R5,R2		;READ INPUT
	CMP/PZ	R2
	BT	LB20
	NEG	R2,R2		;NEGATE IT IF NEGATIVE
LB20:	CMP/GT	R1,R2		;DATA > MIN ?
	BF	notpeak
	MOV	R5,@R4		;STORE DATA ADDRESS
	MOV	R2,R1		;UPDATE MIN
notpeak:
	ADD	#2,R5		;INCREASE DATA ADDRESS
	CMP/HS	R3,R5		;FINISH ?
	BF	loop

	MOV	#0,R0		;RETURN CODE
RTN:	LDS.L	@R15+,PR
	LDS.L	@R15+,MACL
	LDS.L	@R15+,MACH
	MOV	@R15+,R8
	MOV	@R15+,R9
	MOV	@R15+,R10
	MOV	@R15+,R11
	MOV	@R15+,R12
	MOV	@R15+,R13
	RTS
	MOV	@R15+,R14

	.END

