/*
** FILE NAME:	peak.c
**
** PROJECT ID:	94-0040
**
** TITLE:	PeakI
**
** AUTHOR:	Ensigma Ltd.
**
** DESCRIPTION:	This routine searches input to find the first element with
**		the maximum absolute value, and returns its address in peak_ptr.
**
**		int PeakI(peak_ptr, input, no_elements)
**
** PARAMETERS:
**              short **peak_ptr    : address of pointer to peak element
**              short input []      : array of input data
**              long no_elements    : size of the input buffer
**
** RETURNS:     EDSP_OK             : success
**              EDSP_BAD_ARG        : no_elements < 1
**
** MODIFICATION HISTORY:
**              1.0  15-9-95    Initial revision
*/

#include <math.h>
#include <ensigdsp.h>

int 
PeakI(short **peak_ptr, short input[], long no_elements)
{
    /* Variable Declaration */
    int i, location = 0;
    long temp;
    long abs;

    /* Input argument error checking */
    if (no_elements < 1)
	return EDSP_BAD_ARG;

    temp = fabs(input[0]);	/* variable initialisation */

    for (i = 1; i < no_elements; i++)
    {
	/* check for negative */
	abs = fabs(input[i]);

	if (temp < abs)		/* check for maximum */
	{
	    temp = abs;		/* store the abs maximum */
	    location = i;	/* store the index */
	}
    }
    *peak_ptr = &input[location];	/* store the location */

    return EDSP_OK;		/* Return success */
}
