/*
** FILE NAME:   testfft.c
**
** PROJECT ID:  94-0040
**
** TITLE:       FFT test program
**
** AUTHOR:      Ensigma Ltd.
**
** DESCRIPTION: This file contains calls the FFT test routines.
**
** MODIFICATION HISTORY:
**
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <ensigdsp.h>
#include "testhead.h"

#define NFN     20                      /* number of functions */

#ifdef NOPRINTF
/*
** FUNCTION:    printf
**
** DESCRIPTION: Dummy printf function to disable debugging diagnostics  when
**              tests are run on SH hardware
**
** RETURNS:     0
*/
int printf(const char *format,...)
{
    return 0;
}
#endif

char rcode[NFN][100];
int rid = 0;


int debug = 0;

int result=0;

/*
** FUNCTION:    main
**
** AUTHOR:      Ensigma Ltd.
**
** DESCRIPTION: This program calls the functions which test the FFT test
**              functions. The program will stop as soon as any group of
**              tests fails.
**
** PARAMETERS:  None
**
** RETURNS :    void
*/
void
main()
{
    int result, i, j;

    for (i=0; i < NFN; i++)
	for (j=0; j<100; j++)
	    rcode[i][j] = '\0';

    /*
     * Definitions in the test functions must be large enough for transforms of
     * this size
     */
    InitFft(256);
    result = 0;
    sprintf(rcode[rid = 0], "Starting tests\n");
    /** result = TestFft(rcode[rid++]); **/
    if (result != 0)
	exit(result);
    result = TestIfft(rcode[rid++]);
    if (result != 0)
	exit(result);

    exit(0);
}
