;
; FILE NAME:    vectmult.asm
;
; PROJECT ID:   94-0040
;
; TITLE:        VectorMult
;
; AUTHOR:       Ensigma Ltd.
;
; DESCRIPTION:  This file contains the vector multiplication function.
;

	.EXPORT	_VectorMult
	.IMPORT	SHT

;REGISTER USAGE
;
;R4 -> OUTPUT
;R5 -> IP1
;R6 -> IP2
;R7 -> NO
;R0 = SHIFT

	.SECTION	P,CODE,ALIGN=4

; Preserve registers on stack and load stack parameters
_VectorMult:	MOV.L	@R15+,R0	;READ SHIFT
	ADD	#-4,R15
	MOV.L	R14,@-R15	;PUSH REGISTERS ON STACK
	MOV.L	R13,@-R15
	MOV.L	R12,@-R15
	MOV.L	R11,@-R15
	MOV.L	R10,@-R15
	MOV.L	R9,@-R15
	MOV.L	R8,@-R15
	STS.L	MACH,@-R15
	STS.L	MACL,@-R15
	STS.L	PR,@-R15

;ERROR CHECKING
	CMP/PL	R7		;NO >0 ?
	BF	ERR
	CMP/PZ	R0		;SHIFT >=0 ?
	BF	ERR
	MOV	#16,R1
	CMP/GT	R1,R0		;SHIFT > 16 ?
	BF	ST

ERR:	BRA	RTN
	MOV	#1,R0		;R0= RETURN CODE

	.ALIGN	4
ST:	STC	SR,R1
	MOV.W	NONSAT,R2
	AND	R2,R1		;SET S BIT TO 0
	LDC	R1,SR

	MOV	R0,R2
	SHLL2	R2
	SHLL2	R2
	SHLL	R2
	MOV	SHTADDR,R0	;R2=ADDRESS OF SHIFT ROUTINE
	ADD	R2,R0		;R0=SHIFT ROUTINE ADDRESS
	SHLL	R7
	ADD	R4,R7		;R7=LAST OUTPUT ADDRESS+2

ST1:	CLRMAC
	MAC	@R5+,@R6+
	STS	MACL,R8
	STS	MACH,R13

;CALL SHIFT
LB5:	JSR	@R0
	CLRT
	MOV.W	R8,@R4
	ADD	#2,R4

	CMP/EQ	R4,R7
	BF	ST1

	MOV	#0,R0		;RETURN CODE
RTN:	LDS.L	@R15+,PR
	LDS.L	@R15+,MACL
	LDS.L	@R15+,MACH
	MOV	@R15+,R8
	MOV	@R15+,R9
	MOV	@R15+,R10
	MOV	@R15+,R11
	MOV	@R15+,R12
	MOV	@R15+,R13
	RTS
	MOV	@R15+,R14

	.ALIGN	4
SHTADDR	.data.l	SHT
NONSAT	.data.w	H'0FFFD

	.END

